package net.customware.license.support;

import de.schlichtherle.license.LicenseContent;
import de.schlichtherle.license.LicenseContentException;

/**
 * Lightweight classes to add restrictions based on license content.
 * 
 * @author David Peterson
 */
public interface Restriction {
    /**
     * Called to check the the provided content. If there is an issue,
     * throw an exception with the details in the message. 
     * 
     * @param context
     *            The application-specific context to check agains, if appropriate. 
     * @param content
     *            The content to validate.
     * @throws LicenseContentException
     *             if there is a problem with the content.
     */
    void checkRestriction( Object context, LicenseContent content ) throws LicenseContentException;
}
