package net.customware.license.support.feature;

import java.util.Map;

public class DefaultFeatureSet implements FeatureSet {
    private Map<String, Feature> features;

    public DefaultFeatureSet() {
        features = new java.util.HashMap<String, Feature>();
    }

    /*
     * (non-Javadoc)
     * 
     * @see net.customware.license.support.feature.FeatureSet#addFeature(net.customware.license.support.feature.Feature)
     */
    public void addFeature( Feature feature ) {
        features.put( feature.getId(), feature );
    }

    /*
     * (non-Javadoc)
     * 
     * @see net.customware.license.support.feature.FeatureSet#hasFeature(net.customware.license.support.feature.Feature)
     */
    public boolean hasFeature( Feature feature ) {
        return hasFeature( feature.getId() );
    }

    private boolean hasFeature( String featureId ) {
        return features.containsKey( featureId );
    }

    public boolean hasFeatures() {
        return features != null && features.size() > 0;
    }
}
