package net.customware.license.support.feature;

public interface FeatureSet {

    /**
     * Adds a feature to the feature set.
     * 
     * @param feature
     *            The feature to add.
     */
    void addFeature( Feature feature );

    /**
     * Checks if the feature is present.
     * 
     * @param feature
     *            The feature to test for.
     * @return <code>true</code> if the feature is present.
     */
    boolean hasFeature( Feature feature );

    /**
     * Tests if the feature set has any features at all. If no features are
     * present, it is assumed that the license will allow <em>all</em>
     * features to be used.
     * 
     * @return <code>true</code> if any features have been added to the
     *         feature set.
     */
    boolean hasFeatures();

}