package net.customware.license.support.simple;

import java.util.Map;

import de.schlichtherle.license.LicenseContent;

public class SimpleLicenseContent extends LicenseContent {
    public SimpleLicenseContent() {
    }

    /**
     * Sets an attribute for the specified type. Each type can only have one
     * attribute set for it for the lifespan of the instance. The provided value
     * must be an instance of the type. Once an attribute has been set once,
     * future attempts will be ignored and <code>false</code> will be
     * returned.
     * 
     * @param type
     *            The type this attribute is representing.
     * @param value
     *            The value of the object.
     * @return <code>true</code> if the attribute was set successfully.
     */
    public boolean setAttribute( Class<?> type, Object value ) {

        String key = type.getName();
        Map<String, Object> attributes = ( Map<String, Object> ) getExtra();
        if ( attributes == null ) {
            attributes = new java.util.HashMap<String, Object>();
            setExtra( attributes );
        }
        else if ( attributes.containsKey( key ) )
            return false;

        attributes.put( key, value );
        return true;
    }

    public Object getAttribute( Class<?> type ) {
        Map<String, Object> attributes = ( Map<String, Object> ) getExtra();
        if ( attributes != null ) {
            return attributes.get( type.getName() );
        }
        return null;
    }
}
